<?php

namespace Cli\Assets;

class Colors {

    /**
     * @var array
     */
    private static $foreground_colors = [];

    /**
     * @var array
     */
    private static $background_colors = [];

    /**
     * Colors constructor.
     */
    public static function setColors()
    {
        self::$foreground_colors['black'] = '0;30';
        self::$foreground_colors['dark_gray'] = '1;30';
        self::$foreground_colors['blue'] = '0;34';
        self::$foreground_colors['light_blue'] = '1;34';
        self::$foreground_colors['green'] = '0;32';
        self::$foreground_colors['light_green'] = '1;32';
        self::$foreground_colors['cyan'] = '0;36';
        self::$foreground_colors['light_cyan'] = '1;36';
        self::$foreground_colors['red'] = '0;31';
        self::$foreground_colors['light_red'] = '1;31';
        self::$foreground_colors['purple'] = '0;35';
        self::$foreground_colors['light_purple'] = '1;35';
        self::$foreground_colors['brown'] = '0;33';
        self::$foreground_colors['yellow'] = '1;33';
        self::$foreground_colors['light_gray'] = '0;37';
        self::$foreground_colors['white'] = '1;37';

        self::$background_colors['black'] = '40';
        self::$background_colors['red'] = '41';
        self::$background_colors['green'] = '42';
        self::$background_colors['yellow'] = '43';
        self::$background_colors['blue'] = '44';
        self::$background_colors['magenta'] = '45';
        self::$background_colors['cyan'] = '46';
        self::$background_colors['light_gray'] = '47';
    }

    /**
     * @param $string
     * @param null $foreground_color
     * @param null $background_color
     * @return string
     */
    public static function getColoredString($string, $foreground_color = null, $background_color = null)
    {
        self::setColors();

        $colored_string = "";

        if (isset(self::$foreground_colors[$foreground_color])) {
            $colored_string .= "\033[" . self::$foreground_colors[$foreground_color] . "m";
        }

        if (isset(self::$background_colors[$background_color])) {
            $colored_string .= "\033[" . self::$background_colors[$background_color] . "m";
        }


        $colored_string .=  $string . "\033[0m";

        return $colored_string;
    }

    /**
     * @return array
     */
    public function getForegroundColors()
    {
        self::setColors();
        return array_keys(self::$foreground_colors);
    }

    /**
     * @return array
     */
    public function getBackgroundColors()
    {
        self::setColors();
        return array_keys(self::$background_colors);
    }
}